local CustomDecoration = ...

-- Apply building asset processor
CustomDecoration:registerAssetProcessor("models/utility/roofMaterials.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/utility/wallMaterials.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/utility/crenellationMaterials.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/utility/floorGroundMaterials.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/utility/frameMaterials.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/utility/decoration.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/stoneDecoration/decoration.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/stoneDecoration/decoration3.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/stoneDecoration/buttress.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/woodenDecoration/decoration.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/woodenDecoration/decoration3.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/woodenDecoration/stairs.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/woodenDecoration/woodenDecoration.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/woodenDecoration/woodenDecoration2.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/woodenDecoration/woodenDecorationAmerican.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/stainedGlass/stainedGlass.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/metalDecoration/finial.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/stoneDecoration/doors.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
CustomDecoration:registerAssetProcessor("models/woodenDecoration/doors.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Create default building part registering function 
function registerDefaultBuildingPart(_nodePrefix)
	CustomDecoration:register({
		DataType = "BUILDING_PART",
		Id = _nodePrefix .. "_PART",
		ConstructorData = {
                    DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
                    CoreObjectPrefab = _nodePrefix .. "_PREFAB"
                }
	})
end

-- Register Main prefab nodes
CustomDecoration:registerAssetId("models/utility/decoration.fbx/Prefab/decoration/Minor/step_1_Ladder_Tiling1Part", _PrefixAsset .. "_TILING1_PREFAB")
CustomDecoration:registerAssetId("models/utility/decoration.fbx/Prefab/decoration/Minor/step_2_Ladder_Tiling2Part", _PrefixAsset .. "_TILING2_PREFAB")
CustomDecoration:registerAssetId("models/utility/decoration.fbx/Prefab/decoration/Minor/step_0_Ladder_RootPart", _PrefixAsset .. "_ROOT_PREFAB")

registerDefaultBuildingPart(_PrefixAsset .. "_TILING1")
registerDefaultBuildingPart(_PrefixAsset .. "_TILING2")

-- Register default materials
-- Roof (by default: red)
CustomDecoration:registerAssetId("models/stoneDecoration/decoration.fbx/Materials/redRoof", _CommonWindowPrefix .. "_STONE_WINDOW_RED_TILE_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/woodenDecoration/woodenDecoration.fbx/Materials/redRoof", _CommonWindowPrefix .. "_WOODEN_DOOR_RED_TILE_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/woodenDecoration/decoration.fbx/Materials/redRoof", _CommonWindowPrefix .. "_WOODEN_WINDOW_RED_TILE_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/woodenDecoration/doors.fbx/Materials/redRoof", _CommonWindowPrefix .. "_WOODEN_ENTRANCE_RED_TILE_ROOF_MATERIAL")

-- Register optional materials
CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/redRoof", _CommonWindowPrefix .. "_DECORATION_RED_TILE_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/blueRoof", _CommonWindowPrefix .. "_DECORATION_BLUE_TILE_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/brownRoof", _CommonWindowPrefix .. "_DECORATION_BROWN_TILE_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/greyRoof", _CommonWindowPrefix .. "_DECORATION_LIGHT_GREY_TILE_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/grey2Roof", _CommonWindowPrefix .. "_DECORATION_DARK_GREY_TILE_ROOF_MATERIAL")

CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/wRedRoof", _CommonWindowPrefix .. "_DECORATION_RED_SHINGLE_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/wBlueRoof", _CommonWindowPrefix .. "_DECORATION_BLUE_SHINGLE_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/wBrownRoof", _CommonWindowPrefix .. "_DECORATION_BROWN_SHINGLE_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/wYellowRoof", _CommonWindowPrefix .. "_DECORATION_YELLOW_SHINGLE_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/wGreenRoof", _CommonWindowPrefix .. "_DECORATION_GREEN_SHINGLE_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/wManorRoof", _CommonWindowPrefix .. "_DECORATION_WOODEN_MANOR_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/wManor2Roof", _CommonWindowPrefix .. "_DECORATION_STONE_MANOR_ROOF_MATERIAL")

CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/brownMonasteryRoof", _CommonWindowPrefix .. "_DECORATION_BROWN_MONASTERY_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/blueMonasteryRoof", _CommonWindowPrefix .. "_DECORATION_BLUE_MONASTERY_ROOF_MATERIAL")
CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/purpleMonasteryRoof", _CommonWindowPrefix .. "_DECORATION_PURPLE_MONASTERY_ROOF_MATERIAL")

CustomDecoration:registerAssetId("models/utility/roofMaterials.fbx/Materials/strawRoof", _CommonWindowPrefix .. "_DECORATION_STRAW_ROOF_MATERIAL")

-- Wall (by default stone manor)
CustomDecoration:registerAssetId("models/stoneDecoration/decoration.fbx/Materials/murChateau", _CommonWindowPrefix .. "_STONE_DECORATION_STONE_MANOR_WALL_MATERIAL")
CustomDecoration:registerAssetId("models/stoneDecoration/buttress.fbx/Materials/murChateau", _CommonWindowPrefix .. "_STONE_BUTTRESS_STONE_MANOR_WALL_MATERIAL")

-- Register optional materials
CustomDecoration:registerAssetId("models/utility/wallMaterials.fbx/Materials/murChateau", _CommonWindowPrefix .. "_DECORATION_STONE_MANOR_WALL_MATERIAL")
CustomDecoration:registerAssetId("models/utility/wallMaterials.fbx/Materials/brownMonasteryWall", _CommonWindowPrefix .. "_DECORATION_BROWN_MONASTERY_WALL_MATERIAL")
CustomDecoration:registerAssetId("models/utility/wallMaterials.fbx/Materials/blueMonasteryWall", _CommonWindowPrefix .. "_DECORATION_BLUE_MONASTERY_WALL_MATERIAL")
CustomDecoration:registerAssetId("models/utility/wallMaterials.fbx/Materials/purpleMonasteryWall", _CommonWindowPrefix .. "_DECORATION_PURPLE_MONASTERY_WALL_MATERIAL")
CustomDecoration:registerAssetId("models/utility/wallMaterials.fbx/Materials/redStoneWall", _CommonWindowPrefix .. "_DECORATION_RED_STONE_WALL_MATERIAL")
CustomDecoration:registerAssetId("models/utility/wallMaterials.fbx/Materials/sandStoneWall", _CommonWindowPrefix .. "_DECORATION_SAND_STONE_WALL_MATERIAL")
CustomDecoration:registerAssetId("models/utility/wallMaterials.fbx/Materials/giantGateWall", _CommonWindowPrefix .. "_DECORATION_GIANT_GATE_WALL_MATERIAL")
CustomDecoration:registerAssetId("models/utility/wallMaterials.fbx/Materials/whiteChalkWall", _CommonWindowPrefix .. "_DECORATION_WHITE_CHALK_WALL_MATERIAL")
CustomDecoration:registerAssetId("models/utility/wallMaterials.fbx/Materials/woodWall", _CommonWindowPrefix .. "_DECORATION_WOOD_WALL_MATERIAL")

-- Frame (by default white stone)
CustomDecoration:registerAssetId("models/stoneDecoration/decoration.fbx/Materials/whiteStoneFrame", _CommonWindowPrefix .. "_STONE_DECORATION_WHITE_STONE_FRAME_MATERIAL")
CustomDecoration:registerAssetId("models/stoneDecoration/decoration3.fbx/Materials/whiteStoneFrame", _CommonWindowPrefix .. "_STONE_DECORATION3_WHITE_STONE_FRAME_MATERIAL")
CustomDecoration:registerAssetId("models/stoneDecoration/doors.fbx/Materials/whiteStoneFrame", _CommonWindowPrefix .. "_STONE_DOORS_WHITE_STONE_FRAME_MATERIAL")
CustomDecoration:registerAssetId("models/stainedGlass/stainedGlass.fbx/Materials/whiteStoneFrame", _CommonWindowPrefix .. "_STAINED_GLASS_WHITE_STONE_FRAME_MATERIAL")

-- Register optional materials
CustomDecoration:registerAssetId("models/utility/frameMaterials.fbx/Materials/whiteStoneFrame", _CommonWindowPrefix .. "_DECORATION_WHITE_STONE_FRAME_MATERIAL")
CustomDecoration:registerAssetId("models/utility/frameMaterials.fbx/Materials/brownMonasteryFrame", _CommonWindowPrefix .. "_DECORATION_BROWN_MONASTERY_FRAME_MATERIAL")
CustomDecoration:registerAssetId("models/utility/frameMaterials.fbx/Materials/blueMonasteryFrame", _CommonWindowPrefix .. "_DECORATION_BLUE_MONASTERY_FRAME_MATERIAL")
CustomDecoration:registerAssetId("models/utility/frameMaterials.fbx/Materials/purpleMonasteryFrame", _CommonWindowPrefix .. "_DECORATION_PURPLE_MONASTERY_FRAME_MATERIAL")
CustomDecoration:registerAssetId("models/utility/frameMaterials.fbx/Materials/redStoneFrame", _CommonWindowPrefix .. "_DECORATION_RED_STONE_FRAME_MATERIAL")
CustomDecoration:registerAssetId("models/utility/frameMaterials.fbx/Materials/sandStoneFrame", _CommonWindowPrefix .. "_DECORATION_SAND_STONE_FRAME_MATERIAL")
CustomDecoration:registerAssetId("models/utility/frameMaterials.fbx/Materials/giantGateFrame", _CommonWindowPrefix .. "_DECORATION_GIANT_GATE_FRAME_MATERIAL")
CustomDecoration:registerAssetId("models/utility/frameMaterials.fbx/Materials/whiteChalkFrame", _CommonWindowPrefix .. "_DECORATION_WHITE_CHALK_FRAME_MATERIAL")
CustomDecoration:registerAssetId("models/utility/frameMaterials.fbx/Materials/woodFrame", _CommonWindowPrefix .. "_DECORATION_WOOD_FRAME_MATERIAL")

-- Basement
CustomDecoration:registerAssetId("models/utility/basementMaterials.fbx/Materials/murChateau", _CommonWindowPrefix .. "_DECORATION_STONE_MANOR_BASEMENT_MATERIAL")
CustomDecoration:registerAssetId("models/utility/basementMaterials.fbx/Materials/brownMonasteryWall", _CommonWindowPrefix .. "_DECORATION_BROWN_MONASTERY_BASEMENT_MATERIAL")
CustomDecoration:registerAssetId("models/utility/basementMaterials.fbx/Materials/blueMonasteryWall", _CommonWindowPrefix .. "_DECORATION_BLUE_MONASTERY_BASEMENT_MATERIAL")
CustomDecoration:registerAssetId("models/utility/basementMaterials.fbx/Materials/purpleMonasteryWall", _CommonWindowPrefix .. "_DECORATION_PURPLE_MONASTERY_BASEMENT_MATERIAL")
CustomDecoration:registerAssetId("models/utility/basementMaterials.fbx/Materials/redStoneWall", _CommonWindowPrefix .. "_DECORATION_RED_STONE_BASEMENT_MATERIAL")
CustomDecoration:registerAssetId("models/utility/basementMaterials.fbx/Materials/sandStoneWall", _CommonWindowPrefix .. "_DECORATION_SAND_STONE_BASEMENT_MATERIAL")
CustomDecoration:registerAssetId("models/utility/basementMaterials.fbx/Materials/giantGateWall", _CommonWindowPrefix .. "_DECORATION_GIANT_GATE_BASEMENT_MATERIAL")
CustomDecoration:registerAssetId("models/utility/basementMaterials.fbx/Materials/whiteChalkWall", _CommonWindowPrefix .. "_DECORATION_WHITE_CHALK_BASEMENT_MATERIAL")

-- Crenellation
CustomDecoration:registerAssetId("models/utility/crenellationMaterials.fbx/Materials/blueCrenellation", _CommonWindowPrefix .. "_DECORATION_STONE_MANOR_CRENELLATION_MATERIAL")
CustomDecoration:registerAssetId("models/utility/crenellationMaterials.fbx/Materials/brownMonasteryCrenellation", _CommonWindowPrefix .. "_DECORATION_BROWN_MONASTERY_CRENELLATION_MATERIAL")
CustomDecoration:registerAssetId("models/utility/crenellationMaterials.fbx/Materials/blueMonasteryCrenellation", _CommonWindowPrefix .. "_DECORATION_BLUE_MONASTERY_CRENELLATION_MATERIAL")
CustomDecoration:registerAssetId("models/utility/crenellationMaterials.fbx/Materials/purpleMonasteryCrenellation", _CommonWindowPrefix .. "_DECORATION_PURPLE_MONASTERY_CRENELLATION_MATERIAL")
CustomDecoration:registerAssetId("models/utility/crenellationMaterials.fbx/Materials/redStoneCrenellation", _CommonWindowPrefix .. "_DECORATION_RED_STONE_CRENELLATION_MATERIAL")
CustomDecoration:registerAssetId("models/utility/crenellationMaterials.fbx/Materials/sandStoneCrenellation", _CommonWindowPrefix .. "_DECORATION_SAND_STONE_CRENELLATION_MATERIAL")
CustomDecoration:registerAssetId("models/utility/crenellationMaterials.fbx/Materials/giantGateCrenellation", _CommonWindowPrefix .. "_DECORATION_GIANT_GATE_CRENELLATION_MATERIAL")
CustomDecoration:registerAssetId("models/utility/crenellationMaterials.fbx/Materials/whiteChalkCrenellation", _CommonWindowPrefix .. "_DECORATION_WHITE_CHALK_CRENELLATION_MATERIAL")

-- Floor ground
CustomDecoration:registerAssetId("models/utility/floorGroundMaterials.fbx/Materials/whiteStoneGround", _CommonWindowPrefix .. "_DECORATION_WHITE_STONE_FLOOR_GROUND_MATERIAL")
CustomDecoration:registerAssetId("models/utility/floorGroundMaterials.fbx/Materials/woodGround", _CommonWindowPrefix .. "_DECORATION_WOOD_FLOOR_GROUND_MATERIAL")
CustomDecoration:registerAssetId("models/utility/floorGroundMaterials.fbx/Materials/roseSandGround", _CommonWindowPrefix .. "_DECORATION_RED_STONE_FLOOR_GROUND_MATERIAL")

-- Create default minor decoration part registering function 
function registerDefaultDecorationPart(_nameFbxBase, _nameFbxModel, _nameFbx, _nameAsset, _resourceCost, _buildingPartType, _buildingZone)
    CustomDecoration:registerAssetId("models/" .. _nameFbxBase .. ".fbx/Prefab/" .. _nameFbxModel .. "/" .. _nameFbx .. "Part", _PrefixAsset .. "_" ..  _nameAsset .. "_PREFAB")

    function registerDecorationPart(_prefixAssetTop, _resourceCost2, _buildingZone2)
        CustomDecoration:register({
        	DataType = "BUILDING_PART",
	        Id = _prefixAssetTop .. _nameAsset .. "_PART",
	        Name = _prefixAssetTop .. _nameAsset .. "_NAME",
	        Description = _prefixAssetTop .. _nameAsset .. "_DESC",
	        Category = "DECORATION",
                BuildingZone = _buildingZone2,
	        ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		    CoreObjectPrefab = _PrefixAsset .. "_" .. _nameAsset .. "_PREFAB",
                    IsPreviewGroundVisible = false
	        },
	        Cost = {
		    UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
	            },
		    RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			_resourceCost2
		    }
	        }
        })
    end

    registerDecorationPart(_PrefixAsset .. "_TOP_", { Resource = "STONE", Quantity = 0 }, {}) -- pure decoration in order to be set anywhere
    registerDecorationPart(_CommonWindowPrefix .. "_DECORATION_", _resourceCost, _buildingZone)

    -- Register DECORATION_COMP component (no effects in the case no lean wire is defined)
    CustomDecoration:registerPrefabComponent("models/" .. _nameFbxBase .. ".fbx/Prefab/" .. _nameFbxModel .. "/" .. _nameFbx .. "Part", {
	DataType = _PrefixAsset .. "_DECORATION_COMP",
	Enabled = true
    })

    CustomDecoration:registerPrefabComponent("models/" .. _nameFbxBase .. ".fbx/Prefab/" .. _nameFbxModel .. "/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = _buildingPartType
    })

-- Register the root part
    CustomDecoration:register({
	DataType = "BUILDING_PART",
	Id = _PrefixAsset .. "_" .. _nameAsset .. "_ROOT_PART",
	Name = _PrefixAsset .. "_" .. _nameAsset .. "_ROOT_NAME",
	Description = _PrefixAsset .. "_" .. _nameAsset .. "_ROOT_DESC",
	Category = "DECORATION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = _PrefixAsset .. "_ROOT_PREFAB",
		EndPart = _PrefixAsset .. "_TOP_" .. _nameAsset .. "_PART",
		FillerList = {
			_PrefixAsset .. "_TILING2_PART"
                },
		BasementFillerList = {
			_PrefixAsset .. "_TILING1_PART"
         	},
		MinimumScale = 0,
		IsVertical = true,
                IsPreviewGroundVisible = false
	}
    })
end

registerDefaultDecorationPart("stoneDecoration/decoration", "decoration/Minor", "SFenetre", "SFENETRE", { Resource = "STONE", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("stoneDecoration/decoration", "decoration/Minor", "LFenetre", "LFENETRE", { Resource = "STONE", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("stoneDecoration/decoration", "decoration/Minor", "PFenetre", "PFENETRE", { Resource = "STONE", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("stoneDecoration/decoration", "decoration/Minor", "ArrowSlit", "ARROWSLIT", { Resource = "STONE", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("woodenDecoration/decoration", "decoration/Minor", "Lucarne", "LUCARNE", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("woodenDecoration/decoration", "decoration/Minor", "Lucarne3", "LUCARNE_WHITE", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {}) -- white chalk wall
registerDefaultDecorationPart("woodenDecoration/decoration", "decoration/Minor", "LargeLucarne", "LARGE_LUCARNE", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("woodenDecoration/decoration", "decoration/Minor", "LargeLucarneWhite", "LARGE_LUCARNE_WHITE", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("woodenDecoration/decoration", "decoration/Minor", "MediumLucarne", "MEDIUM_LUCARNE", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("woodenDecoration/decoration", "decoration/Minor", "MediumLucarneWhite", "MEDIUM_LUCARNE_WHITE", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("stoneDecoration/decoration", "decoration/Minor", "Balcony", "BALCONY", { Resource = "STONE", Quantity = 2*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("stoneDecoration/decoration", "decoration/Minor", "Chimney", "CHIMNEY", { Resource = "STONE", Quantity = 1*_NoSandbox }, "MINOR", {})

-- Register air vent particle system (smoke)
    CustomDecoration:registerAssetId("models/stoneDecoration/decoration.fbx/Prefab/decoration/Minor/ChimneyPart/SmokeEmitter", "CUSTOM_CHIMNEY_SMOKE_EMITTER_PREFAB")

    CustomDecoration:registerPrefabComponent("models/stoneDecoration/decoration.fbx/Prefab/decoration/Minor/ChimneyPart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
                 { "CUSTOM_CHIMNEY_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
    })

    CustomDecoration:registerPrefabComponent("models/stoneDecoration/decoration.fbx/Prefab/decoration/Minor/ChimneyPart/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = true
    })

    CustomDecoration:registerPrefabComponent("models/stoneDecoration/decoration.fbx/Prefab/decoration/Minor/ChimneyPart/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
    })

registerDefaultDecorationPart("stoneDecoration/decoration", "decoration/Minor", "Tourelle", "TURRET", { Resource = "STONE", Quantity = 2*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("stoneDecoration/decoration", "decoration/Minor", "ChimneyB", "CHIMNEY_B", { Resource = "STONE", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("stoneDecoration/buttress", "commonDecoration", "Buttress", "BUTTRESS", { Resource = "STONE", Quantity = 2*_NoSandbox }, "MAJOR",
               { ZoneEntryList = {
                   { Polygon = polygon.createRectangle( {1, 2} ),
                     Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
               }}
)
registerDefaultDecorationPart("stoneDecoration/decoration3", "commonDecoration", "roundWindow2", "STONE_ROUND_WINDOW", { Resource = "STONE", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("metalDecoration/finial", "decoration/Minor", "Finial1", "FINIAL1", { Resource = "IRON", Quantity = 1*_NoSandbox }, "MAJOR", {})
registerDefaultDecorationPart("metalDecoration/finial", "decoration/Minor", "Finial2", "FINIAL2", { Resource = "IRON", Quantity = 1*_NoSandbox }, "MAJOR", {})
registerDefaultDecorationPart("metalDecoration/finial", "decoration/Minor", "Finial3", "FINIAL3", { Resource = "IRON", Quantity = 1*_NoSandbox }, "MAJOR", {})
registerDefaultDecorationPart("woodenDecoration/decoration", "decoration/Minor", "window9", "WOODEN_WINDOW_9", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("woodenDecoration/woodenDecoration", "woodenDecoration", "door1", "WOODEN_DOOR_1", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MAJOR", {})
registerDefaultDecorationPart("woodenDecoration/woodenDecoration", "woodenDecoration", "door3", "WOODEN_DOOR_3", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MAJOR", {})
registerDefaultDecorationPart("woodenDecoration/woodenDecoration", "woodenDecoration", "door4", "WOODEN_DOOR_4", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MAJOR", {})
registerDefaultDecorationPart("woodenDecoration/woodenDecoration", "woodenDecoration", "window1", "WOODEN_WINDOW_1", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("woodenDecoration/woodenDecoration2", "woodenDecoration", "window3", "WOODEN_WINDOW_3", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("woodenDecoration/woodenDecoration2", "woodenDecoration", "window7", "WOODEN_WINDOW_7", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("woodenDecoration/woodenDecoration2", "woodenDecoration", "window8", "WOODEN_WINDOW_8", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("woodenDecoration/woodenDecoration2", "woodenDecoration", "window18", "WOODEN_WINDOW_18", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("woodenDecoration/woodenDecoration2", "woodenDecoration", "largeWindowWithoutBar", "WOODEN_LARGE_WINDOW", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("woodenDecoration/decoration3", "commonDecoration", "roundWindow1", "WOODEN_ROUND_WINDOW", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("woodenDecoration/stairs", "commonDecoration", "stair1", "WOODEN_STAIRS_1", { Resource = "WOOD", Quantity = 2*_NoSandbox }, "MAJOR", {})
registerDefaultDecorationPart("woodenDecoration/woodenDecoration2", "woodenDecoration", "pointedWindow1", "WOODEN_POINTED_WINDOW_1", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})
registerDefaultDecorationPart("woodenDecoration/woodenDecorationAmerican", "woodenDecoration", "americanWindow1", "WOODEN_AMERICAN_WINDOW_1", { Resource = "WOOD", Quantity = 1*_NoSandbox }, "MINOR", {})

-- Create stained glass minor decoration part registering function 
CustomDecoration:registerAssetId("models/stainedGlass/stainedGlass.fbx/Prefab/commonDecoration/step_0_Ladder_RootPart", _PrefixAsset .. "_STAINED_GLASS_ROOT_PREFAB")
CustomDecoration:registerPrefabComponent("models/stainedGlass/stainedGlass.fbx/Prefab/commonDecoration/step_0_Ladder_RootPart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR"
})

function registerStainedGlassMinorDecorationPart(_nameFbxBase, _nameFbxModel, _nameFbx, _nameAsset, _stoneCost, _prefixRootPrefab)
    CustomDecoration:registerAssetId("models/" .. _nameFbxBase .. ".fbx/Prefab/" .. _nameFbxModel .. "/" .. _nameFbx .. "Part", _PrefixAsset .. "_" ..  _nameAsset .. "_PREFAB")
    CustomDecoration:registerAssetId("models/" .. _nameFbxBase .. ".fbx/Prefab/" .. _nameFbxModel .. "/" .. _nameFbx .. "WSPart", _PrefixAsset .. "_" ..  _nameAsset .. "WS_PREFAB")

    function registerDecorationPart(_prefixAssetTop, _stoneCost2, _stoneColor)
        CustomDecoration:register({
        	DataType = "BUILDING_PART",
	        Id = _prefixAssetTop .. _nameAsset .. "_PART",
	        Name = _prefixAssetTop .. _nameAsset .. "_NAME",
	        Description = _prefixAssetTop .. _nameAsset .. "_DESC",
	        Category = "DECORATION",
	        ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		    CoreObjectPrefab = _PrefixAsset .. "_" .. _nameAsset .. _stoneColor .. "_PREFAB",
                    IsPreviewGroundVisible = false
	        },
	        Cost = {
		    UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
	            },
		    RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "GLASS", Quantity = _stoneCost2*_NoSandbox }
		    }
	        }
        })
        
        if _buildingPartType == "MINOR" then
        else
        end
    end

    registerDecorationPart(_PrefixAsset .. "_TOP_", 0, "") -- standalone
    registerDecorationPart(_CommonChurchPrefix .. "_DECORATION_", _stoneCost, "") -- with church corner stone
    registerDecorationPart(_CommonWindowPrefix .. "_DECORATION_", _stoneCost, "WS") -- with white stones

    function registerMinorBuildingPartType(_stoneColor)
            CustomDecoration:registerPrefabComponent("models/" .. _nameFbxBase .. ".fbx/Prefab/" .. _nameFbxModel .. "/" .. _nameFbx .. _stoneColor .. "Part", {
	        DataType = "COMP_BUILDING_PART",
	        BuildingPartType = "MINOR"
            })
    end
    registerMinorBuildingPartType("") -- with church corner stone
    registerMinorBuildingPartType("WS") -- with white stones

    -- Register DECORATION_COMP component (no effects in the case no lean wire is defined)
    CustomDecoration:registerPrefabComponent("models/" .. _nameFbxBase .. ".fbx/Prefab/" .. _nameFbxModel .. "/" .. _nameFbx .. "Part", {
      	DataType = _PrefixAsset .. "_DECORATION_COMP",
       	Enabled = true
    })

-- Register the root part
    CustomDecoration:register({
	DataType = "BUILDING_PART",
	Id = _PrefixAsset .. "_" .. _nameAsset .. "_ROOT_PART",
	Name = _PrefixAsset .. "_" .. _nameAsset .. "_ROOT_NAME",
	Description = _PrefixAsset .. "_" .. _nameAsset .. "_ROOT_DESC",
	Category = "DECORATION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = _PrefixAsset .. _prefixRootPrefab .. "_ROOT_PREFAB",
		EndPart = _PrefixAsset .. "_TOP_" .. _nameAsset .. "_PART",
		FillerList = {
			_PrefixAsset .. "_TILING2_PART"
                },
		BasementFillerList = {
			_PrefixAsset .. "_TILING1_PART"
         	},
		MinimumScale = 0,
		IsVertical = true
	}
    })
end

registerStainedGlassMinorDecorationPart("stainedGlass/stainedGlass", "commonDecoration", "stainedGlassWindow1", "STAINED_GLASS_WINDOW_1", 10, "")
registerStainedGlassMinorDecorationPart("stainedGlass/stainedGlass", "commonDecoration", "StainedGlass1", "STAINED_GLASS_1", 10, "")
registerStainedGlassMinorDecorationPart("stainedGlass/stainedGlass", "commonDecoration", "StainedGlass2", "STAINED_GLASS_2", 10, "")
registerStainedGlassMinorDecorationPart("stainedGlass/stainedGlass", "commonDecoration", "StainedGlass3", "STAINED_GLASS_3", 10, "")
registerStainedGlassMinorDecorationPart("stainedGlass/stainedGlass", "commonDecoration", "StainedGlass4", "STAINED_GLASS_4", 10, "")
registerStainedGlassMinorDecorationPart("stainedGlass/stainedGlass", "commonDecoration", "StainedGlass8", "STAINED_GLASS_8", 10, "")
registerStainedGlassMinorDecorationPart("stainedGlass/stainedGlass", "commonDecoration", "Splendor2", "SPLENDOR_2", 10, "")

registerStainedGlassMinorDecorationPart("stainedGlass/stainedGlass", "commonDecoration", "PStainedGlass1", "P_STAINED_GLASS_1", 7, "_STAINED_GLASS") -- with lateral minor attachment points on root
registerStainedGlassMinorDecorationPart("stainedGlass/stainedGlass", "commonDecoration", "StainedGlassTall1", "STAINED_GLASS_TALL_1", 7, "_STAINED_GLASS") -- with lateral minor attachment points on root
registerStainedGlassMinorDecorationPart("stainedGlass/stainedGlass", "commonDecoration", "StainedGlassTall2", "STAINED_GLASS_TALL_2", 7, "_STAINED_GLASS" ) -- with lateral minor attachment points on root

-- Create specific decoration part registering function 
function registerDefaultMajorDecorationPart(_nameFbx, _nameAsset, _stoneCost)
    CustomDecoration:registerAssetId("models/stoneDecoration/decoration.fbx/Prefab/decoration/Minor/" .. _nameFbx .. "Part", _PrefixAsset .. "_" ..  _nameAsset .. "_PREFAB")

    function registerDecorationPart(_prefixAssetTop, _stoneCost2)
        CustomDecoration:register({
        	DataType = "BUILDING_PART",
	        Id = _prefixAssetTop .. _nameAsset .. "_PART",
	        Name = _prefixAssetTop .. _nameAsset .. "_NAME",
	        Description = _prefixAssetTop .. _nameAsset .. "_DESC",
	        Category = "DECORATION",
	        ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		    CoreObjectPrefab = _PrefixAsset .. "_" .. _nameAsset .. "_PREFAB",
                    IsPreviewGroundVisible = false
	        },
	        Cost = {
		    UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
	            },
		    RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = _stoneCost2*_NoSandbox }
		    }
	        }
        })
    end

    registerDecorationPart(_PrefixAsset .. "_TOP_", 0)
-- not refactored yet    registerDecorationPart(_CommonWindowPrefix .. "_DECORATION_", 1)

    -- Register DECORATION_COMP component (no effects in the case no lean wire is defined)
    CustomDecoration:registerPrefabComponent("models/stoneDecoration/decoration.fbx/Prefab/decoration/Minor/" .. _nameFbx .. "Part", {
	DataType = _PrefixAsset .. "_DECORATION_COMP",
	Enabled = true
    })

-- Register the root part
    CustomDecoration:register({
	DataType = "BUILDING_PART",
	Id = _PrefixAsset .. "_" .. _nameAsset .. "_ROOT_PART",
	Name = _PrefixAsset .. "_" .. _nameAsset .. "_ROOT_NAME",
	Description = _PrefixAsset .. "_" .. _nameAsset .. "_ROOT_DESC",
	Category = "DECORATION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = _PrefixAsset .. "_ROOT_PREFAB",
		EndPart = _PrefixAsset .. "_TOP_" .. _nameAsset .. "_PART",
		FillerList = {
			_PrefixAsset .. "_TILING2_PART"
                },
		BasementFillerList = {
			_PrefixAsset .. "_TILING1_PART"
         	},
		MinimumScale = 0,
		IsVertical = true
	}
    })
end

registerDefaultMajorDecorationPart("DoorA", "DOOR_A", 1)
registerDefaultMajorDecorationPart("DoorB", "DOOR_B", 1)

-- Doors used as entrance of a monument
-- Create default door decoration part registering function 
function registerDefaultDoorDecorationPart(_nameFbxBase, _nameFbx, _nameAsset, _resource, _cost)
    CustomDecoration:registerAssetId("models/" .. _nameFbxBase .. ".fbx/Prefab/decoration/Entrance/" .. _nameFbx .. "Part", _CommonDoorPrefix .. "_ENTRANCE_" .. _nameAsset .. "_PREFAB")

    CustomDecoration:register({
	DataType = "BUILDING_PART",
	Id = _CommonDoorPrefix .. "_ENTRANCE_" .. _nameAsset .. "_PART",
	Name = _CommonDoorPrefix .. "_ENTRANCE_" .. _nameAsset .. "_NAME",
	Description = _CommonDoorPrefix .. "_ENTRANCE_" .. _nameAsset .. "_DESC",
	Category = "DOOR",
        BuildingZone = { ZoneEntryList = {
            { Polygon = polygon.createRectangle( {1, 1} ),
              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } },
            { Polygon = polygon.createRectangle( {1, 1} ),
              Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } }
        }},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = _CommonDoorPrefix .. "_ENTRANCE_" .. _nameAsset .. "_PREFAB",
                IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = _resource, Quantity = _cost*_NoSandbox }
		}
	}
    })

-- Register grounding components
    CustomDecoration:registerPrefabComponent("models/" .. _nameFbxBase .. ".fbx/Prefab/decoration/Entrance/" .. _nameFbx .. "Part", {
	DataType = "COMP_GROUNDED"
    })

    CustomDecoration:registerPrefabComponent("models/" .. _nameFbxBase .. ".fbx/Prefab/decoration/Entrance/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "DOOR"
    })
end

registerDefaultDoorDecorationPart("stoneDecoration/doors", "IntegratedDoorA", "DOOR_A", "STONE", 1)
registerDefaultDoorDecorationPart("stoneDecoration/doors", "IntegratedDoorB", "DOOR_B", "STONE", 1)
registerDefaultDoorDecorationPart("woodenDecoration/doors", "IntegratedWoodenDoorC", "WOODEN_DOOR_C", "WOOD", 1)
registerDefaultDoorDecorationPart("woodenDecoration/doors", "IntegratedWoodenDoorD", "WOODEN_DOOR_D", "WOOD", 2)
registerDefaultDoorDecorationPart("woodenDecoration/doors", "IntegratedWoodenDoorE", "WOODEN_DOOR_E", "WOOD", 2)
registerDefaultDoorDecorationPart("woodenDecoration/woodenDecorationAmerican", "IntegratedAmericanDoor1", "WOODEN_AMERICAN_DOOR_1", "WOOD", 2)

